﻿Imports System
Imports System.Collections
Imports System.Data
Imports System.Configuration
Imports System.IO
Imports System.Collections.Generic
Imports Telerik.Web.UI.Widgets

Public Class CustomContentProvider
    Inherits FileSystemContentProvider

    Private Collection As Collection

    Public Sub New(ByVal context As HttpContext, ByVal searchPatterns As String(), ByVal viewPaths As String(), ByVal uploadPaths As String(), ByVal deletePaths As String(), ByVal selectedUrl As String, _
        ByVal selectedItemTag As String)
        MyBase.New(context, searchPatterns, viewPaths, uploadPaths, deletePaths, selectedUrl, _
            selectedItemTag)
    End Sub

    Public Overloads Overrides Function ResolveDirectory(ByVal path As String) As DirectoryItem

        Dim childFiles() As FileItem = Me.GetFiles(path)
        Dim dirName As String = path.Substring(VirtualPathUtility.RemoveTrailingSlash(path).LastIndexOf("/"))
        Dim emptyDirsArray() As DirectoryItem

        Dim newFolder As DirectoryItem = New DirectoryItem(dirName, path, path, "", PathPermissions.Read, childFiles, emptyDirsArray)


        Return newFolder

    End Function

    Public Overloads Overrides Function ResolveRootDirectoryAsTree(ByVal path As String) As DirectoryItem

        Dim childDirs() As DirectoryItem = Me.GetDirectories(path)
        Dim dirName As String = path.Substring(VirtualPathUtility.RemoveTrailingSlash(path).LastIndexOf("/"))
        Dim emptyFilesArray() As FileItem

        Dim newFolder As DirectoryItem = New DirectoryItem(dirName, path, path, "", PathPermissions.Read, emptyFilesArray, childDirs)


        Return newFolder
    End Function


    Private Function GetDirectories(ByVal parentDir As String) As DirectoryItem()

        parentDir = VirtualPathUtility.AppendTrailingSlash(parentDir)

        Dim actualVirtualDirPath As String = parentDir.Substring(0, parentDir.IndexOf("/", Me.Context.Request.ApplicationPath.Length + 1))
        Dim actualPhysicalDirPath As String = Context.Server.MapPath(actualVirtualDirPath)
        Dim restOfPath As String = parentDir.Substring(actualVirtualDirPath.Length + 1).Replace("/", "__") ' Does not include starting '/' sybol

        Dim result As New List(Of DirectoryItem)
        Dim dirinfo As DirectoryInfo = New DirectoryInfo(actualPhysicalDirPath)
        For Each fileInfo As FileInfo In dirinfo.GetFiles(String.Format("{0}*", restOfPath)) ' restOfPath LOOKS LIKE '1000__21212__'

            Dim fileName As String = fileInfo.Name
            Dim restOfFileNameAsDir As String = fileInfo.Name.Substring(restOfPath.Length)
            Dim indexOf__ As Int32 = restOfFileNameAsDir.IndexOf("__")
            If indexOf__ <> -1 Then

                Dim resultDirectoryName As String = restOfFileNameAsDir.Substring(0, indexOf__)
                Dim resultDirectoryPath As String = parentDir + restOfFileNameAsDir.Substring(0, restOfFileNameAsDir.IndexOf("__"))

                Dim emptyDirsArray() As DirectoryItem
                Dim emptyFilesArray() As FileItem
                Dim newDirItem As DirectoryItem = New DirectoryItem(resultDirectoryName, resultDirectoryPath, resultDirectoryPath, "", PathPermissions.Read, emptyFilesArray, emptyDirsArray)
                result.Add(newDirItem)
            End If

        Next
        Return result.ToArray()

    End Function

    Private Function GetFiles(ByVal parentDir As String) As FileItem()

        parentDir = VirtualPathUtility.AppendTrailingSlash(parentDir)

        Dim actualVirtualDirPath As String = parentDir.Substring(0, parentDir.IndexOf("/", Me.Context.Request.ApplicationPath.Length + 1))
        Dim actualPhysicalDirPath As String = Context.Server.MapPath(actualVirtualDirPath)
        Dim restOfPath As String = parentDir.Substring(actualVirtualDirPath.Length + 1).Replace("/", "__") ' Does not include starting '/' sybol

        Dim result As New List(Of FileItem)
        Dim dirinfo As DirectoryInfo = New DirectoryInfo(actualPhysicalDirPath)
        For Each fileInfo As FileInfo In dirinfo.GetFiles(String.Format("{0}*", restOfPath)) ' restOfPath LOOKS LIKE '1000__21212__'

            Dim fileName As String = fileInfo.Name
            Dim resultFileName As String = fileInfo.Name.Substring(restOfPath.Length)
            Dim indexOf__ As Int32 = resultFileName.IndexOf("__")
            If indexOf__ = -1 Then ' A file

                Dim resultFilePath As String = parentDir + resultFileName
                Dim newFileItem As FileItem = New FileItem(resultFileName, fileInfo.Extension, fileInfo.Length, resultFilePath, resultFilePath, "", PathPermissions.Read)
                result.Add(newFileItem)
            End If

        Next
        Return result.ToArray()

    End Function


    Private Function IsFiltered(ByVal name As String) As Boolean
        If name.ToLower().EndsWith(".sys") OrElse name.ToLower().Contains("_sys") OrElse name.Contains("Flower") Then
            Return True
        End If

        ' else
        Return False
    End Function

    Private Function FolderNameFromFileName(ByVal name As String) As String

        Dim filename() As String
        Dim foldername As String
        filename = name.Split("__")
        foldername = filename(filename.Count() - 1).ToString
        Return foldername
    End Function

    Public Function GetFileNameWithOutExt(ByVal flname As String) As String

        'Get the filename without the path or extension.
        'Input Values:
        '   flname - path and filename of file.
        'Return Value:
        '   GetFileNameWithOutExt - name of file without the extension.

        Dim posn As Integer, i As Integer
        Dim fName As String

        posn = 0
        'find the position of the last "\" character in filename
        For i = 1 To Len(flname)
            If (Mid(flname, i, 1) = "\") Then posn = i
        Next i

        'get filename without path
        fName = Right(flname, Len(flname) - posn)

        'get filename without extension
        posn = InStr(fName, ".")
        If posn <> 0 Then
            fName = Left(fName, posn - 1)
        End If
        GetFileNameWithOutExt = fName
    End Function

End Class
